|===============================
|Tokens d'Excution de fonctions
|===============================
		.include  "os.h"
		
		.include  "Defines.h"
		.include  "Tbl_Errors.h"
		.include  "TokensExec.h"
		.include  "GFATEM.h"

                .xdef     ExecFnc_At
                .xdef     ExecCmd_Print

_Exec_exit:
		rts
                
ExecFnc_At:
		rts


_ExecCmd_Print_integer:
		move.l    (%a0),-(%SP)
		pea.l     printf_ld(%PC)
		jbsr      printf
		addq.l    #8,%SP
		jbra      _ExecCmd_Print_next_continue
		
_ExecCmd_Print_float:
		move.w    8(%a0),-(%SP)
		move.l    4(%a0),-(%SP)
		move.l    (%a0),-(%SP)
		pea.l     printf_f(%PC)
		jbsr      printf
		lea.l     14(%SP),%SP
		jbra      _ExecCmd_Print_next_continue
		
_ExecCmd_Print_bool:
		move.b    (%a0),%d0				|Force le flottant  tre sur 16 Bits signs
		ext.w     %d0
		move.w    %d0,-(%SP)
		pea.l     printf_d(%PC)
		jbsr      printf
		addq.l    #6,%SP
		jbra      _ExecCmd_Print_next_continue
		
_ExecCmd_Print_string:
		|pea.l     printf_s(%PC)
		jbra      _ExecCmd_Print_next_continue
		
_ExecCmd_Print_apost:
		pea.l     printf_space(%PC)
		jsr       printf
		addq.l    #4,%SP
		jbra      _ExecCmd_Print_continue
		
_ExecCmd_Print_eofline:
		pea.l     printf_eofline(%PC)
		jsr       printf
		addq.l    #4,%SP
		jbra      _ExecCmd_Print_continue

ExecCmd_Print:
		jsr       TokensExec_CNumArg
		movea.l   ptrEnd_ES(%PC),%a5			|Place la pile au dbut de la premire donnes
		lea.l     -8(%a5),%a5
		dbf       %d6,_ExecCmd_Print_loop
_ExecCmd_Print_eofline2:		
		pea.l     printf_eofline(%PC)
		jsr       printf
		addq.l    #4,%SP
		rts
		
_ExecCmd_Print_loop:
		move.b    (%a5),%d0				|Oprande		
		move.b    1(%a5),%d1				|Type
		jbsr      TokensExec_CheckTableVar
		tst.w     %d7
		jbeq      _Exec_exit
		
		cmpi.b    #OPRD_POINT_VIRGULE,%d0		|Continue pour point virgule
		jbeq      _ExecCmd_Print_continue
		cmpi.b    #OPRD_APOST,%d0
		jbeq      _ExecCmd_Print_apost
		
		|Affichage donnes
		movea.l   4(%a5),%a0				|Donnes
		
		cmpi.b    #TYPE_INTEGER,%d1
		jbeq      _ExecCmd_Print_integer
		cmpi.b    #TYPE_FLOAT,%d1
		jbeq      _ExecCmd_Print_float
		cmpi.b    #TYPE_BOOL,%d1
		jbeq      _ExecCmd_Print_bool
		cmpi.b    #TYPE_STRING,%d1
		jbeq      _ExecCmd_Print_string

_ExecCmd_Print_next_continue:
		|Saut de ligne
		tst.l     %d6
		jbeq      _ExecCmd_Print_eofline2
		move.b    -8(%a5),%d0				|Oprande suivante
		cmpi.b    #OPRD_POINT_VIRGULE,%d0
		jbeq      _ExecCmd_Print_continue
		cmpi.b    #OPRD_APOST,%d0
		jbne      _ExecCmd_Print_eofline
		    
_ExecCmd_Print_continue:
		subq.l    #8,%a5				|Donnes suivante
		dbf       %d6,_ExecCmd_Print_loop
		rts
		
		.end
		